#ifndef PARTIALWIDTH_h
#define PARTIALWIDTH_h
/********************************************/
/* class to evaluate the user defined width */
/********************************************/
//----------------
#include "Moses.h"
//----------------
#include "parameters.h"
#include "couplings.h"
#include "mosesParticle.h"


using namespace std;

namespace Moses1 {

	class partialWidth : public couplings {
	public:
		partialWidth();
		virtual ~partialWidth();
		// to return the partialWidth
		
		virtual double getpartialWidth(dcomplex gplus, dcomplex gminus,
						pdtParticle &propagator, customParticle &fermion,
						physicalParameters &physPrm);
		
		virtual double getpartialWidth(unsigned int nMode, double s,
		     				pdtParticle &propagator, customParticle &fermion,
						physicalParameters &physPrm); // overload with "double s"
		
		virtual double getpartialWidth(double s, pdtParticle &propagator, customParticle &outFermion,
						physicalParameters &physPrm, double mZprime);

	
		virtual double  getpartialMassiveGWidth(unsigned int Lambda_I,unsigned int nMode,double s,
							pdtParticle &propagator, customParticle &outFermion, double &outHelicity1,double &outHelicity2,
							physicalParameters &physPrm, couplings &Gcouplings);

};

}
#endif
